unit heizkostenabrechnung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TForm1 = class(TForm)
    EditHeizoel: TEdit;
    EditStrom: TEdit;
    EditWartung: TEdit;
    EditSchornstein: TEdit;
    EditAblese: TEdit;
    summe: TLabel;
    aufwohnflaecheentfallen: TLabel;
    aufverbrauchentfallen: TLabel;
    prowe: TLabel;
    proqm: TLabel;
    StringGrid1: TStringGrid;
    Berechnen: TButton;
    summeko: TLabel;
    NeuBerechnen: TButton;
    Beenden: TButton;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure BerechnenClick(Sender: TObject);
    procedure BeendenClick(Sender: TObject);
    procedure NeuBerechnenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
  type Spalten = array[1..8] of real;
     var Spaltensumme: array[1..8]of real;
         werte:        array[1..14] of Spalten;

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
     var i: integer;

begin
   with stringgrid1 do
    begin
      cells[0,0]:= 'Wohn.Nr.';
      cells[1,0]:= 'Wohnflche qm';
      cells[2,0]:= 'KostenWo';
      cells[3,0]:= 'Verbrauch Einheiten';
      cells[4,0]:= 'KostenVer';
      cells[5,0]:= 'insgesamt DM';
      cells[6,0]:= 'gezahlte Pauschale';
      cells[7,0]:= 'Nachzahlung(-)/Gutschrift(+)';


     for i:=1 to RowCount-1 do Cells[0,i]:=IntToStr(i);
        cells[0,13]:= 'Summe:';
    Options:= [goFixedVertLine, goFixedHorzLine, goHorzLine, goVertLine,
               goRowMoving, goColSizing, goEditing, goTabs]
     end;
end;


procedure TForm1.BerechnenClick(Sender: TObject);
 var heizoel, strom, wartung, schornstein, ablese,
     Summekosten, Wohnflaeche, Verbrauch,
     Quadratmeter, Waermeeinheit          :         real;
     i,z,x,y                              :         integer;

  begin
   heizoel    := strtofloat(EditHeizoel.text);
   strom      := strtofloat(EditStrom.text);
   wartung    := strtofloat(EditWartung.text);
   schornstein:= strtofloat(EditSchornstein.text);
   ablese     := strtofloat(EditAblese.text);

   SummeKosten      :=   heizoel + strom + wartung + schornstein + ablese;
    SummeKo.caption :=   formatfloat('0.00',Summekosten);
   Wohnflaeche      :=   SummeKosten * 0.3;
   Verbrauch        :=   SummeKosten * 0.7;
    aufWohnflaecheEntfallen.caption:= Formatfloat('0.00',Wohnflaeche);
    aufVerbrauchEntfallen.caption  := Formatfloat('0.00',Verbrauch);

    with stringgrid1 do
     begin
      for z:=1 to ColCount-1 do
       begin
            Spaltensumme[z]:=0;
       end;
      for i:=1 to RowCount-2 do
       begin
      for z:=1 to ColCount-1 do
       begin
            if cells[z,i]='' then cells[z,i]:= '0';
            werte[z,i]:=    strtofloat(cells[z,i]);
            Spaltensumme[z]:= Spaltensumme[z] + werte[z,i];
            cells[z,13]:=   formatfloat('0.00',Spaltensumme[z]);
        end;
        end;

            Quadratmeter  := Wohnflaeche/Spaltensumme[1];
            Waermeeinheit := Verbrauch/Spaltensumme[3];
             proQm.caption:= Formatfloat('0.00',Quadratmeter );
             proWe.caption:= Formatfloat('0.00',Waermeeinheit);

      for y:=1 to ColCount-1 do
       begin
            Spaltensumme[y]:=0;
       end;
      for x:=1 to RowCount-2 do
       begin
      for y:=1 to ColCount-1 do
       begin
            if cells[y,x]= '' then cells[y,x]:='0';
            werte[y,x]:=    strtofloat(cells[y,x]);
            werte[2,x]:=      werte[1,x]*Quadratmeter;
            cells[2,x]:=    formatfloat('0.00',werte[2,x]);
            werte[4,x]:=      werte[3,x]*Waermeeinheit;
            cells[4,x]:=    formatfloat('0.00',werte[4,x]);
            werte[5,x]:=      werte[2,x]+werte[4,x];
            cells[5,x]:=    formatfloat('0.00',werte[5,x]);
            werte[7,x]:=      werte[6,x]-werte[5,x];
            cells[7,x]:=    formatfloat('0.00',werte[7,x]);
            Spaltensumme[y]:= Spaltensumme[y]+werte[y,x];
            cells[y,13]    :=   formatfloat('0.00',Spaltensumme[y]);
        end;
       end;
      end;
     end;

procedure TForm1.NeuBerechnenClick(Sender: TObject);
    var i,z: integer;

     begin
            with stringgrid1 do
             begin
            for i:=1 to RowCount-1 do
             begin
            for z:=1 to ColCount-1 do
             begin
                  cells[z,i]:='';
             end;
             end;

                  EditHeizoel.text               := '';
                  EditStrom.text                 := '';
                  EditWartung.text               := '';
                  EditSchornstein.text           := '';
                  EditAblese.text                := '';
                  SummeKo.caption                := '';
                  aufWohnflaecheEntfallen.caption:= '';
                  aufVerbrauchEntfallen.caption  := '';
                  proQm.caption                  := '';
                  proWe.caption                  := '';
             end;
      end;

procedure TForm1.BeendenClick(Sender: TObject);
   begin
        form1.close
   end;

end.
